#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "C:\WINCE600\PUBLIC\COMMON\OAK\INC\windev.h"

//#define MINI2451		1
//#define MINI2440		1
#define MINI6410		1
//#define IDEA6410		1

HWND hDlg;
HANDLE hGPIO;
HANDLE hEventStopThread;
HANDLE hThread;
unsigned char ledState[4];


#ifdef MINI2440
#include "C:\WINCE600\PLATFORM\Mini2440\SRC\INC\gpio.h"

#define NB_LEDS				4
#define NB_BUTTONS			6
GPIO_SET_PIN_OUTPUT_VALUE	ledPinValue[NB_LEDS];					// pin configuration of the 4 leds
GPIO_GET_PIN_INPUT_VALUE	buttonPinValue[NB_BUTTONS];				// pin configuration of the 6 buttons
#endif

#ifdef MINI2451
#include "C:\WINCE600\PLATFORM\Mini2451\SRC\INC\gpio.h"

#define NB_LEDS				4
#define NB_BUTTONS			4
GPIO_SET_PIN_OUTPUT_VALUE	ledPinValue[NB_LEDS];					// pin configuration of the 4 leds
GPIO_GET_PIN_INPUT_VALUE	buttonPinValue[NB_BUTTONS];				// pin configuration of the 6 buttons
#endif

#ifdef MINI6410
#include "C:\WINCE600\PLATFORM\SMDK6410\SRC\INC\gpio.h"

#define NB_LEDS				4
#define NB_BUTTONS			6
GPIO_SET_PIN_OUTPUT_VALUE	ledPinValue[NB_LEDS];					// pin configuration of the 4 leds
GPIO_GET_PIN_INPUT_VALUE	buttonPinValue[NB_BUTTONS];				// pin configuration of the 6 buttons
#endif

#ifdef IDEA6410
#include "C:\WINCE600\PLATFORM\SMDK6410\SRC\INC\gpio.h"

#define NB_LEDS				4
#define NB_BUTTONS			6
GPIO_SET_PIN_OUTPUT_VALUE	ledPinValue[NB_LEDS];					// pin configuration of the 4 leds
GPIO_GET_PIN_INPUT_VALUE	buttonPinValue[NB_BUTTONS];				// pin configuration of the 6 buttons
#endif

// toggle the state of a led
void toggleLedState(unsigned char ledIndex) {
	WCHAR wTemp[50];
	GPIO_SET_PIN_OUTPUT_VALUE gpioPinValue;

	gpioPinValue.portNumber = ledPinValue[ledIndex].portNumber;
	gpioPinValue.pinNumber = ledPinValue[ledIndex].pinNumber;
	if (ledState[ledIndex] == 0) {
		swprintf_s(wTemp, 50, L"LED %d OFF", ledIndex-4);
		ledState[ledIndex] = 1;
		gpioPinValue.pinValue = ON;
	} else {
		swprintf_s(wTemp, 50, L"LED %d ON", ledIndex-4);
		ledState[ledIndex] = 0;
		gpioPinValue.pinValue = OFF;
	}
	if (!DeviceIoControl(hGPIO, IOCTL_GPIO_SET_PIN_OUTPUT_VALUE, &gpioPinValue, sizeof(GPIO_SET_PIN_OUTPUT_VALUE), NULL, 0, 0, NULL)) {
		MessageBox(NULL, L"Error returned by IOCTL_GPIO_SET_PIN_OUTPUT_VALUE\n", L"ERROR", MB_OK);
	}

	switch (ledIndex) {
		case 0:
			SetDlgItemTextW(hDlg, IDC_LED1, wTemp);
			break;
		case 1:
			SetDlgItemTextW(hDlg, IDC_LED2, wTemp);
			break;
		case 2:
			SetDlgItemTextW(hDlg, IDC_LED3, wTemp);
			break;
		case 3:
			SetDlgItemTextW(hDlg, IDC_LED4, wTemp);
			break;
	}
}

// get the state of a button and update the displayed state
void updateButtonsState(unsigned char buttonIndex) {
	GPIO_GET_PIN_INPUT_VALUE gpioPinValue;
	unsigned long idcCheck;
	gpioPinValue.portNumber = buttonPinValue[buttonIndex].portNumber;
	gpioPinValue.pinNumber  = buttonPinValue[buttonIndex].pinNumber;
	switch(buttonIndex) {
		case 0:
			idcCheck = IDC_CHECK1;
			break;
		case 1:
			idcCheck = IDC_CHECK2;
			break;
		case 2:
			idcCheck = IDC_CHECK3;
			break;
		case 3:
			idcCheck = IDC_CHECK4;
			break;
		case 4:
			idcCheck = IDC_CHECK5;
			break;
		case 5:
			idcCheck = IDC_CHECK6;
			break;
	}

	if (!DeviceIoControl(hGPIO, IOCTL_GPIO_GET_PIN_INPUT_VALUE, &gpioPinValue, sizeof(GPIO_GET_PIN_INPUT_VALUE), NULL, 0, 0, NULL)) {
		MessageBox(NULL, L"Error returned by IOCTL_GPIO_GET_PIN_INPUT_VALUE\n", L"ERROR", MB_OK);
	} else {
		if (gpioPinValue.pinValue == ON) {
			SendMessage(GetDlgItem(hDlg,idcCheck),BM_SETCHECK,BST_CHECKED,0);
		} else {
			SendMessage(GetDlgItem(hDlg,idcCheck),BM_SETCHECK,BST_UNCHECKED,0);
		}
	}
}

// function called at dialog closing (= when the application ends)
void CloseApplication() {
	SetEvent(hEventStopThread);
	Sleep(250);
	CloseHandle(hEventStopThread);
	CloseHandle(hThread);
	CloseHandle(hGPIO);
}

// function called at dialog creation (= when the application starts)
void startApplication() {
	int i;
	GPIO_SET_PIN_CONFIGURATION gpioInit;

#ifdef MINI2440
	ledPinValue[0].portNumber = PORT_B;
	ledPinValue[0].pinNumber  = 5;
	ledPinValue[1].portNumber = PORT_B;
	ledPinValue[1].pinNumber  = 6;
	ledPinValue[2].portNumber = PORT_B;
	ledPinValue[2].pinNumber  = 7;
	ledPinValue[3].portNumber = PORT_B;
	ledPinValue[3].pinNumber  = 8;

	buttonPinValue[0].portNumber = PORT_G;
	buttonPinValue[0].pinNumber  = 0;
	buttonPinValue[1].portNumber = PORT_G;
	buttonPinValue[1].pinNumber  = 3;
	buttonPinValue[2].portNumber = PORT_G;
	buttonPinValue[2].pinNumber  = 5;
	buttonPinValue[3].portNumber = PORT_G;
	buttonPinValue[3].pinNumber  = 6;
	buttonPinValue[4].portNumber = PORT_G;
	buttonPinValue[4].pinNumber  = 7;
	buttonPinValue[5].portNumber = PORT_G;
	buttonPinValue[5].pinNumber  = 11;
#endif

#ifdef MINI2451
	ledPinValue[0].portNumber = PORT_B;
	ledPinValue[0].pinNumber  = 5;
	ledPinValue[1].portNumber = PORT_B;
	ledPinValue[1].pinNumber  = 6;
	ledPinValue[2].portNumber = PORT_A;
	ledPinValue[2].pinNumber  = 25;
	ledPinValue[3].portNumber = PORT_A;
	ledPinValue[3].pinNumber  = 26;

	buttonPinValue[0].portNumber = PORT_F;
	buttonPinValue[0].pinNumber  = 0;
	buttonPinValue[1].portNumber = PORT_F;
	buttonPinValue[1].pinNumber  = 1;
	buttonPinValue[2].portNumber = PORT_F;
	buttonPinValue[2].pinNumber  = 2;
	buttonPinValue[3].portNumber = PORT_F;
	buttonPinValue[3].pinNumber  = 3;
#endif

#ifdef MINI6410
	ledPinValue[0].portNumber = PORT_K;
	ledPinValue[0].pinNumber  = 4;
	ledPinValue[1].portNumber = PORT_K;
	ledPinValue[1].pinNumber  = 5;
	ledPinValue[2].portNumber = PORT_K;
	ledPinValue[2].pinNumber  = 6;
	ledPinValue[3].portNumber = PORT_K;
	ledPinValue[3].pinNumber  = 7;

	buttonPinValue[0].portNumber = PORT_N;
	buttonPinValue[0].pinNumber  = 0;
	buttonPinValue[1].portNumber = PORT_N;
	buttonPinValue[1].pinNumber  = 1;
	buttonPinValue[2].portNumber = PORT_N;
	buttonPinValue[2].pinNumber  = 2;
	buttonPinValue[3].portNumber = PORT_N;
	buttonPinValue[3].pinNumber  = 3;
	buttonPinValue[4].portNumber = PORT_N;
	buttonPinValue[4].pinNumber  = 4;
	buttonPinValue[5].portNumber = PORT_N;
	buttonPinValue[5].pinNumber  = 5;
#endif

#ifdef IDEA6410
	ledPinValue[0].portNumber = PORT_M;
	ledPinValue[0].pinNumber  = 0;
	ledPinValue[1].portNumber = PORT_M;
	ledPinValue[1].pinNumber  = 1;
	ledPinValue[2].portNumber = PORT_M;
	ledPinValue[2].pinNumber  = 2;
	ledPinValue[3].portNumber = PORT_M;
	ledPinValue[3].pinNumber  = 3;

	buttonPinValue[0].portNumber = PORT_N;
	buttonPinValue[0].pinNumber  = 0;
	buttonPinValue[1].portNumber = PORT_N;
	buttonPinValue[1].pinNumber  = 1;
	buttonPinValue[2].portNumber = PORT_N;
	buttonPinValue[2].pinNumber  = 2;
	buttonPinValue[3].portNumber = PORT_N;
	buttonPinValue[3].pinNumber  = 3;
	buttonPinValue[4].portNumber = PORT_N;
	buttonPinValue[4].pinNumber  = 4;
	buttonPinValue[5].portNumber = PORT_N;
	buttonPinValue[5].pinNumber  = 5;
#endif

	// led initialization
	gpioInit.pinConfiguration	= OUTPUT;	
	gpioInit.pinValue			= OFF;
	for (i=0; i<NB_LEDS; i++) {
		ledPinValue[i].pinValue = OFF;
		ledState[i] = 0;
		gpioInit.portNumber = ledPinValue[i].portNumber;		
		gpioInit.pinNumber  = ledPinValue[i].pinNumber;		
		if (!DeviceIoControl(hGPIO, IOCTL_GPIO_SET_PIN_CONFIGURATION, &gpioInit, sizeof(GPIO_SET_PIN_CONFIGURATION), NULL, 0, 0, NULL)) {
			MessageBox(NULL, L"Error returned by IOCTL_GPIO_SET_PIN_CONFIGURATION\n", L"ERROR", MB_OK);
			return;
		}
	}

	// input button initialization
	gpioInit.pinConfiguration = INPUT_WITH_PULLUP;
	for (i=0; i<NB_BUTTONS; i++) {
		gpioInit.portNumber = buttonPinValue[i].portNumber;		
		gpioInit.pinNumber  = buttonPinValue[i].pinNumber;		
		if (!DeviceIoControl(hGPIO, IOCTL_GPIO_SET_PIN_CONFIGURATION, &gpioInit, sizeof(GPIO_SET_PIN_CONFIGURATION), NULL, 0, 0, NULL)) {
			MessageBox(NULL, L"Error returned by IOCTL_GPIO_SET_PIN_CONFIGURATION\n", L"ERROR", MB_OK);
			return;
		}
	}
}

// this thread will update the displayed state of each button of the mini2440
unsigned long ThreadProc(void) {
	unsigned char goOn = 1;
	int i;
	DWORD retWait;

	while(goOn) {
		retWait = WaitForSingleObject(hEventStopThread, 100);
		if (retWait == WAIT_OBJECT_0) {
			// suicide du thread demand
			goOn = 0;
		} else {
			for (i=0; i<NB_BUTTONS; i++) {
				updateButtonsState(i);
			}
		}
	}
	return 0;
}


LRESULT CALLBACK MainProc(HWND Dlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	int Select;

	switch(message)
	{
		case WM_INITDIALOG:
			startApplication();
			break;
		case WM_COMMAND:
			Select=LOWORD(wParam);
			switch(Select)
			{
				case IDC_LED1:
					toggleLedState(0);
					break;
				case IDC_LED2:
					toggleLedState(1);
					break;
				case IDC_LED3:
					toggleLedState(2);
					break;
				case IDC_LED4:
					toggleLedState(3);
					break;
			}
			break;
		case WM_CLOSE:				
			CloseApplication();
			EndDialog(hDlg,0);
			PostQuitMessage(0);
			return TRUE;
			break;
	}
	return false;
}

int APIENTRY WinMain(HINSTANCE hInstance,
						HINSTANCE hPrevInstance,
						LPTSTR lpCmdLine,
						int nCmdShow)
{
	MSG msg;

	// we first open the driver
	hGPIO = CreateFile(L"GPI0:", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);
	if (hGPIO == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, L"TestGPIO : error while opening GPIO driver\n", L"ERROR", MB_OK);
		return -1;
	}

	/* Chargement des botes de dialogue */
	hDlg = CreateDialog(hInstance,(LPCTSTR)IDD_DIALOG,NULL,(DLGPROC)MainProc);
	ShowWindow(hDlg,SW_SHOW);

	// stop thread event creation
	hEventStopThread = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (hEventStopThread == NULL) {
		MessageBox(NULL, L"Error during stop thread event creation", L"ERROR", MB_OK);
		return -1;
	}

	// thread creation
	hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ThreadProc,0,0,NULL);
	if (NULL == hThread ) {
		MessageBox(NULL, L"Error during thread creation", L"ERROR", MB_OK);
		return - 1;
	}

	/* Boucle de gestion des messages */
	while(GetMessage(&msg,NULL,0,0)==TRUE)
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}